## ecflow 4.9.0

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_CXX_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
##############################################################################

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

# ===========================================================================
# Change the default if NO CMAKE_BUILD_TYPE specified
if (NOT DEFINED CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release CACHE STRING "Build Configuration type" FORCE)
endif()


project( ecflow CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
# ecbuild_info( "CMAKE_MODULE_PATH    : ${CMAKE_MODULE_PATH}")

include( ecbuild_system )

ecbuild_requires_macro_version( 1.6 )


###############################################################################
# local project

ecbuild_declare_project()

# =========================================================================================
# VERSION  
# Get the ecflow version specified in 'VERSION.cmake'. This is only accessible after ecbuild_declare_project()
# The ecflow version config is done in ACore directory
# =========================================================================================

ecbuild_info( "CMAKE_INSTALL_PREFIX     : ${CMAKE_INSTALL_PREFIX}" )
ecbuild_info( "ECFLOW_RELEASE           : ${ECFLOW_RELEASE}" )
ecbuild_info( "ECFLOW_MAJOR             : ${ECFLOW_MAJOR}" )
ecbuild_info( "ECFLOW_MINOR             : ${ECFLOW_MINOR}" )
ecbuild_info( "ECFLOW_VERSION           : ${ECFLOW_VERSION_STR}" )

# =========================================================================================
# Options , be aware of caching, when modifying on the command line. 
# Ideally start fresh or remove cache CmakeCache.txt in build dir
# =========================================================================================
option( ENABLE_SERVER              "Build the server, can be switched off if just building UI" ON  )
option( ENABLE_PYTHON              "enable python interface"         ON  )
option( ENABLE_UI                  "Build ecFlowUI"                  ON  ) 
option( ENABLE_GUI                 "Build ecflowview"                ON  )
option( ENABLE_STATIC_BOOST_LIBS   "Link with boost libs statically" ON  )
option( ENABLE_ALL_TESTS           "This includes performance/migration/regression tests" OFF )
option( ENABLE_UI_BACKTRACE        "Print a UI debug backtrace"         OFF ) 
option( ENABLE_UI_USAGE_LOG        "Enable UI usage logging"            OFF )
option( ENABLE_SSL                 "Enable SSL encrypted communication" OFF )
option( ENABLE_SECURE_USER         "Enable passwords for user"          OFF )
option( ENABLE_PYTHON_PTR_REGISTER "Some compilers/boost versions do not register shared ptr automatically" OFF  )

# =========================================================================================
# Qt for ecFlowUI. 
# Algorithm: we test for Qt5 - if it's there, then use it; otherwise look for Qt4.
#            if we don't find that, then we cannot build ecFlowUI.
# =========================================================================================
if(ENABLE_UI)

    ecbuild_info("")
    ecbuild_info("------------------------------ Qt start ---------------------------")
    ecbuild_info("ecFlowUI is enabled - searching for Qt5; if not found, will try Qt4")
    ecbuild_info("To use a self-built Qt installation, try setting CMAKE_PREFIX_PATH")

    find_package(Qt5Widgets 5.0.0)
    if (Qt5Widgets_FOUND)
        find_package(Qt5Gui 5.0.0)
        if (Qt5Gui_FOUND)
            find_package(Qt5Network 5.0.0)
            if (Qt5Network_FOUND)
                find_package(Qt5Svg 5.0.0)
            endif()
        endif()
    endif()

    if (Qt5Widgets_FOUND AND Qt5Gui_FOUND AND Qt5Network_FOUND AND Qt5Svg_FOUND)
          ecbuild_info("Qt5 version ${Qt5Widgets_VERSION_STRING} was found")
          set(ECFLOW_QT_INCLUDE_DIR ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIR} ${Qt5Network_INCLUDE_DIR} ${Qt5Svg_INCLUDE_DIR})
          set(ECFLOW_QT_LIBRARIES   ${Qt5Widgets_LIBRARIES}    ${Qt5Gui_LIBRARIES}   ${Qt5Network_LIBRARIES} ${Qt5Svg_LIBRARIES})
          set(ECFLOW_QT5 1)
          add_definitions(-DECFLOW_QT5)
    else()
        ecbuild_info("Could not find all required Qt5 packages (Qt5Widgets, Qt5Gui and Qt5Network) - searching for Qt4")
        ecbuild_info(" ** To use a self-built Qt installation, try setting CMAKE_PREFIX_PATH **")

        find_package(Qt4 4.8.0 REQUIRED QtCore QtGui QtNetwork QtSvg)
        if(QT_FOUND)
            ecbuild_info("Found Qt 4, please ignore any warnings about Qt5 components that were not found.")
        else()
            ecbuild_info(" ** To use a self-built Qt installation, try setting CMAKE_PREFIX_PATH **")
            ecbuild_critical("Qt5 and Qt4 not found - one of these is required for ecFlowUI; or use -DENABLE_UI=OFF")
        endif()
    endif()

    set(ECFLOW_QT 1)
    add_definitions(-DQT_NO_KEYWORDS) # We need to disable keywords because there is a problem in using Qt and boost together.
    ecbuild_info("------------------------------ Qt end----------------------------")
    ecbuild_info("")

endif()


# sanity check - cannot set ENABLE_UI_BACKTRACE if UI is OFF
if(ENABLE_UI_BACKTRACE AND (NOT ENABLE_UI))
	ecbuild_warn("Cannot ENABLE_UI_BACKTRACE if UI is not enabled")
    set(ENABLE_UI_BACKTRACE OFF)
endif()

# sanity check - cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI and ENABLE_UI_BACKTRACE are OFF
if(UI_BACKTRACE_EMAIL_ADDRESS_FILE AND (NOT ENABLE_UI))
	ecbuild_warn("Cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI is not enabled")
    set(UI_BACKTRACE_EMAIL_ADDRESS_FILE)
endif()

# sanity check - cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is OFF
if(UI_LOG_FILE AND (NOT ENABLE_UI_USAGE_LOG))
	ecbuild_warn("Cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is not enabled")
	set(UI_LOG_FILE)
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_FILE))
	ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_SITE_TAG
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_SITE_TAG))
	ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_SITE_TAG must also be set")
endif()


ecbuild_info( "ENABLE_SERVER              : ${ENABLE_SERVER}" )
ecbuild_info( "ENABLE_PYTHON              : ${ENABLE_PYTHON}" )
ecbuild_info( "ENABLE_PYTHON_PTR_REGISTER : ${ENABLE_PYTHON_PTR_REGISTER}" )
ecbuild_info( "ENABLE_GUI                 : ${ENABLE_GUI}" )
ecbuild_info( "ENABLE_UI                  : ${ENABLE_UI}" )
ecbuild_info( "ENABLE_ALL_TESTS           : ${ENABLE_ALL_TESTS}" )
ecbuild_info( "ENABLE_STATIC_BOOST_LIBS   : ${ENABLE_STATIC_BOOST_LIBS}" )
ecbuild_info( "ENABLE_SSL                 : ${ENABLE_SSL}" )
ecbuild_info( "ENABLE_SECURE_USER         : ${ENABLE_SECURE_USER}" )


if (ENABLE_UI)
	ecbuild_info( "ENABLE_UI_BACKTRACE      : ${ENABLE_UI_BACKTRACE}" )
	if(UI_BACKTRACE_EMAIL_ADDRESS_FILE)
		ecbuild_info( "UI_BACKTRACE_EMAIL_ADDRESS_FILE : ${UI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
	endif()

	ecbuild_info( "ENABLE_UI_USAGE_LOG      : ${ENABLE_UI_USAGE_LOG}" )
	if(ENABLE_UI_USAGE_LOG)
		ecbuild_info( "UI_LOG_FILE              : ${UI_LOG_FILE}" )
		ecbuild_info( "UI_LOG_SITE_TAG          : ${UI_LOG_SITE_TAG}" )
	endif()
endif()
ecbuild_info("")

# ======================================================================================
# GUI requires X11 and Motif
# ======================================================================================

if(ENABLE_GUI)
  find_package( X11 )
#  if ( X11_FOUND )
#	   ecbuild_debug_var( X11_INCLUDE_DIR )
#	   ecbuild_debug_var( X11_LIBRARIES )  
#	   ecbuild_debug_var( X11_Xt_INCLUDE_PATH )
#	   ecbuild_debug_var( X11_Xt_LIB )
#	   ecbuild_debug_var( X11_Xpm_INCLUDE_PATH )
#	   ecbuild_debug_var( X11_Xpm_LIB )
#  endif()

  find_package( Motif )
#  if ( MOTIF_FOUND )
#	   ecbuild_debug_var( MOTIF_INCLUDE_DIR )
#	   ecbuild_debug_var( MOTIF_LIBRARIES )  
#  endif()
endif()
 
# =========================================================================================
# Boost
# =========================================================================================

# this can help in some situations:
set (_CMAKE_PREFIX_PATH_BACKUP ${CMAKE_PREFIX_PATH}) # make a backup of CMAKE_PREFIX_PATH
foreach(BOOST_PATH_TO_SEARCH ${BOOST_PATH} ${BOOST_ROOT} $ENV{BOOST_ROOT})
    ecbuild_debug("adding: ${BOOST_PATH_TO_SEARCH} to CMAKE_PREFIX_PATH")
    list(APPEND CMAKE_PREFIX_PATH ${BOOST_PATH_TO_SEARCH})
    list(REMOVE_DUPLICATES CMAKE_PREFIX_PATH)
endforeach()


# Ecflow test require statics libs for boost < 1.59, otherwise get double free error.
# To use static boost python ensure that Boost_USE_STATIC_LIBS is set on.
# See: http://www.cmake.org/cmake/help/v3.0/module/FindBoost.html
if ( ENABLE_STATIC_BOOST_LIBS )
    set(Boost_USE_STATIC_LIBS ON)
endif()
set(Boost_USE_MULTITHREADED      ON)
set(Boost_NO_SYSTEM_PATHS        ON)
set(Boost_DETAILED_FAILURE_MSG   ON)
#set(Boost_DEBUG                 ON)

if ( ENABLE_PYTHON )
	find_package( Boost 1.53.0 REQUIRED COMPONENTS python serialization system thread unit_test_framework test_exec_monitor filesystem program_options date_time regex)
else()
	find_package( Boost 1.53.0 REQUIRED COMPONENTS serialization system thread unit_test_framework test_exec_monitor filesystem program_options date_time regex)
endif()

# Available boost lib should be referenced as:
#
#    ${Boost_SYSTEM_LIBRARY}
#    ${Boost_SERIALIZATION_LIBRARY}
#    ${Boost_THREAD_LIBRARY}
#    ${Boost_FILESYSTEM_LIBRARY}
#    ${Boost_PROGRAM_OPTIONS_LIBRARY}
#    ${Boost_DATE_TIME_LIBRARY}
#
#    ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} 
#    ${Boost_TEST_EXEC_MONITOR_LIBRARY} 

#ecbuild_info( "Boost_LIBRARIES     : ${Boost_LIBRARIES}" )


if (NOT "${CMAKE_PREFIX_PATH}" EQUAL "${_CMAKE_PREFIX_PATH_BACKUP}")
    set (CMAKE_PREFIX_PATH ${_CMAKE_PREFIX_PATH_BACKUP}) # restore CMAKE_PREFIX_PATH
    ecbuild_debug("Resetting CMAKE_PREFIX_PATH to ${CMAKE_PREFIX_PATH}")
endif()

# =======================================================================
# SSL
# =======================================================================
if (ENABLE_SSL)
    find_package(OpenSSL REQUIRED)
    if (NOT OPENSSL_FOUND )
        ecbuild_error("Can not find openssl libraries")
    endif() 
    include_directories( ${OPENSSL_INCLUDE_DIR} )
    add_definitions( -DECF_OPENSSL )
endif()

# =======================================================================
# SECURE_USER
# =======================================================================
if (ENABLE_SECURE_USER)
    add_definitions( -DECF_SECURE_USER )
endif()


# =========================================================================================
# debug
# =========================================================================================

if( CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]" )

	ecbuild_info( "INFO: DEBUG BUILD" )

    # Tell C/C++ that we're doing a debug build
    add_definitions( -DDEBUG )

endif()

# =========================================================================================
# CLANG: /usr/local/include/boost/type_traits/is_base_and_derived.hpp:226:42: 
#           fatal error: recursive template instantiation exceeded maximum depth of 256
# =========================================================================================
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftemplate-depth=1024")

=== Pyext/CMakeLists.txt ===
### ecflow python bindings
# NOTES:
#
# To see the python link line: Do python-config  --ldflags, i.e
#   > /usr/local/apps/python/2.7.8-01/bin/python-config  --ldflags
#   > -lpthread -ldl -lutil -lm -lpython2.7 -Xlinker -export-dynamic
#
# However on cct we get:
#   > /usr/local/apps/python/2.7.5-01/bin/python-config --ldflags
#   > -L/usr/local/apps/python/2.7.5-01/lib/python2.7/config -lpthread -ldl -lutil -lm -lpython2.7 -Xlinker -export-dynamic
#
# cct is correct as it has the "-L" but on other machines we rely on /usr/lib/libpython2.7.so.1.0 being there!
# lxop-test does not have /usr/lib/libpython2.7.so.1.0 so ecbuild fails
#
# For problems with the python build, please look in <build-dir>/ecbuild.log, typically non developmental python
# installs may not include python libs or includes
# For ubuntoo to install we need:
#    sudo apt-get install libpython-dev
#

file( GLOB srcs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "src/*.cpp" "src/*.hpp" )

# =====================================================================
# local includes
include_directories(  
                     ../ACore/src 
                     ../ANattr/src
                     ../ANode/src
                     ../Base/src
                     ../Base/src/cts
                     ../Base/src/stc
                     ../Client/src
                     ../CSim/src
                    )

# =====================================================================     
# INCLUDES here is for external includes   
#   NOINSTALL this stops double install, the one in i.e lib/ecflow.so
#             The other install is in python2.7/site-packages/ecflow.so
# if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty
ecbuild_add_library( TARGET    ecflow
                     NOINSTALL
                     TYPE      MODULE
                     SOURCES   ${srcs}
					 CONDITION PYTHONLIBS_FOUND
                     LIBS      libclient libsimu base node nodeattr core
                               ${PYTHON_LIBRARIES} ${OPENSSL_LIBRARIES}
                     INCLUDES 
                               ${Boost_INCLUDE_DIRS}
                               ${PYTHON_INCLUDE_DIRS}
                    )


# This ensures that for debug config, we only link with debug boost libs, for other configs, we link with optimised boost libs 
if (   PYTHONLIBS_FOUND )             
   target_link_libraries(ecflow debug      ${Boost_PYTHON_LIBRARY_DEBUG}   )
   target_link_libraries(ecflow optimized  ${Boost_PYTHON_LIBRARY_RELEASE} )
endif()

#
# Override default behaviour that add RPATHS during install
# The only thing that seem to work is set INSTALL_RPATH to ""
# Using SKIP_BUILD_RPATH,BUILD_WITH_INSTALL_RPATH,INSTALL_RPATH_USE_LINK_PATH
# had no effect
#         
# by default cmake add prefix 'lib', we don't want this hence disable
set_target_properties(ecflow PROPERTIES 
                             PREFIX ""
                             INSTALL_RPATH ""
                     )
                     
# =====================================================================
# tests 

ecbuild_add_test( TARGET py_u_TestMigrate
                  TYPE PYTHON 
                  ARGS ${CMAKE_CURRENT_SOURCE_DIR}/migrate/py_u_TestMigrate.py
                  ENVIRONMENT "PYTHONPATH=${CMAKE_BINARY_DIR}/Pyext" )

list( APPEND u_tests
        py_u_test_add   
        py_u_test_collection   
        py_u_test_cron  
        py_u_test_defs_constructor 
        py_u_test_get_attr  
        py_u_test_manual   
        py_u_test_late   
        py_u_test_replace_node   
        py_u_test_tutorial   
        py_u_TestAddDelete   
        py_u_TestAddDeleteFunc 
        py_u_TestAddNodeFunc  
        py_u_TestAutoAddExtern  
        py_u_TestCopy        
        py_u_TestDefs         
        py_u_TestDefsCheck    
        py_u_TestDerivable   
        py_u_TestEcf  
        py_u_TestError        
        py_u_TestFind        
        py_u_TestFlag      
        py_u_TestGetAllTasks   
        py_u_TestJobGeneration 
        py_u_TestParent        
        py_u_TestRemove
        py_u_TestRepeatArithmetic
        py_u_TestSimulator  
        py_u_TestTraversal     
        py_u_TestUserManual    
        py_u_TestWith         
)
foreach( test ${u_tests} )

    ecbuild_add_test( TARGET ${test} 
                      TYPE PYTHON 
                      ARGS        ${CMAKE_CURRENT_SOURCE_DIR}/test/${test}.py
                      ENVIRONMENT "PYTHONPATH=${CMAKE_BINARY_DIR}/Pyext" 
                      TEST_DEPENDS u_base
                     )
endforeach()


if ( ENABLE_ALL_TESTS AND ENABLE_SERVER)
	list( APPEND s_tests
	             py_s_TestClientApi    
	             py_s_TestPythonChildApi
	)
	
	foreach( test ${s_tests} )
	
	    ecbuild_add_test( TARGET ${test} 
	                      TYPE PYTHON 
	                      ARGS        ${CMAKE_CURRENT_SOURCE_DIR}/test/${test}.py
	                      ENVIRONMENT "PYTHONPATH=${CMAKE_BINARY_DIR}/Pyext" 
	                      TEST_DEPENDS u_base
	                     )
	endforeach()
	
	set_property(TEST py_s_TestClientApi      APPEND PROPERTY DEPENDS s_test)
	set_property(TEST py_s_TestPythonChildApi APPEND PROPERTY DEPENDS py_s_TestClientApi)
endif()


# =============================================================================
# Configure __init__.py to add __version__
# =============================================================================

set(INIT_PY_IN  "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py.in")
set(INIT_PY_OUT "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py")

configure_file(${INIT_PY_IN} ${INIT_PY_OUT} )


# ==========================================================================
# install
#    -DCMAKE_PYTHON_INSTALL_TYPE = [ local | setup | not defined ]
#
#    local | not defined : this will install to:
#                          $INSTALL_PREFIX/$release.$major.$minor/lib/python2.7/site-packages/ecflow/
#    setup               : experimental only,python way of installing
#
#    -DCMAKE_PYTHON_INSTALL_PREFIX should *only* used when using python setup.py (CMAKE_PYTHON_INSTALL_TYPE=setup)
#    *AND* for testing python install to local directory
#
# Note:  To install only the python module
#       cd  buildir
#       cmake -DCMAKE_INSTALL_PREFIX=$INSTALL_DIR -DCOMPONENT=python -P cmake_install.cmake -- make install
# ==========================================================================
   
if( CMAKE_PYTHON_INSTALL_TYPE MATCHES  "local"  OR NOT DEFINED CMAKE_PYTHON_INSTALL_TYPE )
   
      message(STATUS "python install *LOCAL* +++ lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/ecflow +++++++")
      set(PYTHON_SITE "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages" )
      set(PYTHON_DEST "${PYTHON_SITE}/ecflow" )
      
      install( TARGETS ecflow                 DESTINATION ${PYTHON_DEST}  RENAME ecflow.so COMPONENT python )
      install( FILES   ecflow/__init__.py     DESTINATION ${PYTHON_DEST}                   COMPONENT python )
      
      # Install files that Axel has asked for. 
      # These are example of what Axel uses as a layer over ecflow api, for operations
      install( FILES   samples/api/ecf.py     DESTINATION ${PYTHON_DEST}                COMPONENT python )
      install( FILES   samples/api/sms2ecf.py DESTINATION ${PYTHON_DEST}                COMPONENT python )
      
else()
	  message( STATUS "python found,  CMAKE_PYTHON_INSTALL_TYPE=${CMAKE_PYTHON_INSTALL_TYPE}")

      # -------------------------------------------------------------------------------------
      # Install using setup.py
      # See: http://bloerg.net/2012/11/10/cmake-and-distutils.html
      # -------------------------------------------------------------------------------------
      message(STATUS "python install using *setup.py* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")
      message(STATUS "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}")
      message(STATUS "CMAKE_BINARY_DIR=${CMAKE_BINARY_DIR}")
      message(STATUS "CMAKE_PYTHON_INSTALL_PREFIX : ${CMAKE_PYTHON_INSTALL_PREFIX}" )  
    
      set(SETUP_PY_IN "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
      set(SETUP_PY    "${CMAKE_CURRENT_SOURCE_DIR}/setup.py")
      set(DEPS        "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py")
      set(OUTPUT      "${CMAKE_CURRENT_SOURCE_DIR}/timestamp")

      configure_file(${SETUP_PY_IN} ${SETUP_PY} )

      add_custom_command(OUTPUT ${OUTPUT}
                       COMMAND ${PYTHON} ${SETUP_PY} build
                       COMMAND ${CMAKE_COMMAND} -E touch ${OUTPUT}
                       DEPENDS ${DEPS})
      add_custom_target(target ALL DEPENDS ${OUTPUT})


      install(CODE "execute_process(COMMAND ${PYTHON} ${SETUP_PY} build_ext)")
    
	  if( DEFINED CMAKE_PYTHON_INSTALL_PREFIX )
         message(STATUS "custom/*test* python install prefix defined CMAKE_PYTHON_INSTALL_PREFIX=${CMAKE_PYTHON_INSTALL_PREFIX}")
         install(CODE "execute_process(COMMAND ${PYTHON} ${SETUP_PY} install -f --prefix=${CMAKE_PYTHON_INSTALL_PREFIX})")
      else()
         install(CODE "execute_process(COMMAND ${PYTHON} ${SETUP_PY} install)")
      endif()
endif()

# ====================================================================================
ecbuild_dont_pack( DIRS 
                   test/data/CUSTOMER
)

# ignore files with passwords
ecbuild_dont_pack( FILES 
                   .pydevproject
                   samples/test.py
                   samples/confluence_add_attachment.py
)

=== tools/CMakeLists.txt ===
#
# Configure  ecflow_site.sh. This is used in ecflow_start.sh and ecflow_stop.sh
# Used in coping with start of ecflow server on a linux cluser
# Avoid's hard copy mention of paths specific to ECMWF

if( DEFINED SITE_SPECIFIC_SERVER_SCRIPT )

	macro(install_symlink filepath sympath)
    	install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${filepath} ${sympath})")
    	install(CODE "message(\"-- Created symlink: ${sympath} -> ${filepath}\")")
	endmacro(install_symlink)
	
    install_symlink(${SITE_SPECIFIC_SERVER_SCRIPT} ${CMAKE_INSTALL_PREFIX}/bin/ecflow_site.sh )

endif()

install( FILES
            ${CMAKE_SOURCE_DIR}/tools/ecflow_fuse.py
            ${CMAKE_SOURCE_DIR}/tools/ecflow_logsvr.pl
            ${CMAKE_SOURCE_DIR}/tools/noconnect.sh
            ${CMAKE_SOURCE_DIR}/tools/ecflow_start.sh
            ${CMAKE_SOURCE_DIR}/tools/ecflow_stop.sh
            ${CMAKE_SOURCE_DIR}/tools/ecflow_logserver.sh
         DESTINATION bin
         PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
         COMPONENT binary
       )

=== Viewer/src/CMakeLists.txt ===

set(viewer_srcs   
    ViewerMain.cpp
    AboutDialog.cpp
    AbstractNodeModel.cpp
    AbstractNodeView.cpp
    AbstractSearchLine.cpp
    AbstractTextEditSearchInterface.cpp
    ActionHandler.cpp
    Animation.cpp
    AstCollateVNodesVisitor.cpp
    AttributeEditor.cpp
    AttributeEditorFactory.cpp   
    CaseSensitiveButton.cpp
    ChangeNotify.cpp
    ChangeNotifyDialog.cpp
    ChangeNotifyEditor.cpp
    ChangeNotifyModel.cpp
    ChangeNotifyWidget.cpp
    ClockWidget.cpp
    CodeItemWidget.cpp
    ComboMulti.cpp
    CommandDesignerWidget.cpp
    CommandHandler.cpp
    CommandOutput.cpp
    CommandOutputDialog.cpp
    CommandOutputWidget.cpp
    CompactView.cpp
    ConfigListDelegate.cpp
    ConnectState.cpp
    CustomCommandDialog.cpp
    CustomCommandHandler.cpp
    CustomListWidget.cpp
    CustomTabWidget.cpp
    Dashboard.cpp
    DashboardDialog.cpp
    DashboardDock.cpp
    DashboardTitle.cpp
    DashboardWidget.cpp
    DirectoryHandler.cpp
    EditItemWidget.cpp
    EditProvider.cpp
    EditorInfoLabel.cpp
    ExpandState.cpp
    ExpandStateNode.cpp
    FlagSet.hpp
    FileInfoLabel.cpp
    FileWatcher.cpp
    FilterWidget.cpp
    FontMetrics.cpp
    GotoLineDialog.cpp
    Highlighter.cpp
    HistoryItemWidget.cpp
    HtmlEdit.cpp
    HtmlItemWidget.cpp
    IconProvider.cpp
    InfoPanel.cpp 
    InfoPanelItem.cpp   
    InfoPanelHandler.cpp
    InfoProvider.cpp
    InputEventLog.cpp
    JobItemWidget.cpp
    LabelEditor.cpp
    LimitEditor.cpp
    LineEdit.cpp
    LogModel.cpp
    LogProvider.cpp  
    LogTruncator.cpp
    MainWindow.cpp
    ManualItemWidget.cpp 
    MenuConfigDialog.cpp
    MenuHandler.cpp
    MessageLabel.cpp
    MessageItemWidget.cpp
    MeterEditor.cpp
    ModelColumn.cpp
    NodeExpression.cpp
    NodeFilterDialog.cpp    
    NodePanel.cpp
    NodePathWidget.cpp
    NodeQuery.cpp
    NodeQueryCombo.cpp
    NodeQueryEditor.cpp
    NodeQueryEngine.cpp
    NodeQueryHandler.cpp
    NodeQueryOption.cpp
    NodeQueryOptionEdit.cpp
    NodeQueryResult.cpp
    NodeQueryResultModel.cpp
    NodeQueryResultView.cpp
    NodeQueryViewDelegate.cpp
    NodeSearchDialog.cpp
    NodeSearchWidget.cpp
    NodeViewBase.cpp
    NodeViewDelegate.cpp
    NodeWidget.cpp
    OneLineTextEdit.cpp
    OutputBrowser.cpp
    OutputCache.cpp
    OutputClient.cpp
    OutputFetchInfo.cpp
    OutputFileClient.cpp
    OutputDirClient.cpp
    OutputModel.cpp
    OutputItemWidget.cpp
    OutputFileProvider.cpp
    OutputDirProvider.cpp
    OverviewItemWidget.cpp
    OverviewProvider.cpp
    Palette.cpp  
    PlainTextEdit.cpp
    PlainTextSearchLine.cpp
    PlainTextSearchInterface.cpp
    PropertyDialog.cpp
    PropertyEditor.cpp
    PropertyLine.cpp
    PropertyMapper.cpp
    RectMetrics.cpp
    RepeatEditor.cpp
    RichTextEdit.cpp
    RichTextSearchInterface.cpp
    RichTextSearchLine.cpp
    SaveSessionAsDialog.cpp
    ScriptItemWidget.cpp
    ServerComInfoWidget.cpp
    ServerComQueue.cpp
    ServerComThread.cpp
    ServerDefsAccess.cpp
    ServerHandler.cpp
    ServerFilter.cpp
    ServerItem.cpp
    ServerList.cpp
    ServerListDialog.cpp
    ServerListSyncWidget.cpp
    ServerSettingsItemWidget.cpp
    SessionDialog.cpp
    SessionRenameDialog.cpp
    SessionHandler.cpp
    ShellCommand.cpp
    Sound.cpp
    StandardView.cpp
    StringMatchCombo.cpp
    StringMatchMode.cpp
    SuiteItemWidget.cpp
    SuiteFilter.cpp
    SuiteFilterObserver.hpp
    SuiteModel.cpp
    TabWidget.cpp 
    TableFilterWidget.cpp
    TableNodeModel.cpp
    TableNodeSortModel.cpp
    TableNodeView.cpp
    TableNodeViewDelegate.cpp
    TableNodeWidget.cpp
    TextEditSearchLine.cpp
    TextFilterHandler.cpp
    TextFilterHandlerDialog.cpp
    TextFilterWidget.cpp
    TextFormat.cpp
    TimeItemWidget.cpp
    TreeNodeModel.cpp
    TreeNodeView.cpp
    TreeNodeViewDelegate.cpp
    TreeNodeWidget.cpp
    TreeView.cpp
    TriggerEditor.cpp   
    TriggerItemWidget.cpp
    TriggerTextWidget.cpp    
    TriggerCollector.cpp
    TriggerTableModel.cpp
    TriggerTableView.cpp
    TriggerTableWidget.cpp
    TriggerViewDelegate.cpp
    TriggeredScanner.cpp
    UIDebug.cpp
    UiLog.cpp
    UpdateTimer.cpp
    UserMessage.cpp
    VAttribute.cpp
    VAttributeType.cpp
    VConfig.cpp   
    VConfigLoader.cpp
    VDateAttr.cpp
    VDir.cpp
    VEventAttr.cpp
    VFilter.cpp
    VIcon.cpp
    VInfo.cpp
    VFile.cpp
    VFileInfo.cpp
    VItem.cpp
    VItemPathParser.cpp
    VLabelAttr.cpp
    VLateAttr.cpp
    VLimitAttr.cpp
    VLimiterAttr.cpp
    VMeterAttr.cpp
    VModelData.cpp
    VNode.cpp
    VNodeList.cpp
    VNodeMover.cpp
    VNState.cpp
    VParam.cpp
    VProperty.cpp   
    VRepeatAttr.cpp
    VReply.cpp
    VServerSettings.cpp
    VSettings.cpp
    VSState.cpp
    VTask.cpp
    VTaskNode.cpp
    VTimeAttr.cpp
    VTree.cpp
    VTriggerAttr.cpp
    VGenVarAttr.cpp
    VUserVarAttr.cpp
    VariableEditor.cpp
    VariableModel.cpp
    VariableModelData.cpp
    VariableItemWidget.cpp
    VariableSearchLine.cpp
    VariableView.cpp
    ViewerUtil.cpp
    WhyItemWidget.cpp
    WidgetNameProvider.cpp
    WmWorkspaceHandler.cpp
    ZombieItemWidget.cpp
    ZombieModel.cpp
    TextPager/TextPagerCursor.cpp
    TextPager/TextPagerDocument.cpp
    TextPager/TextPagerEdit.cpp
    TextPager/TextPagerLayout_p.cpp
    TextPager/TextPagerSearchHighlighter.cpp
    TextPager/TextPagerSearchInterface.cpp
    TextPager/TextPagerSection.cpp
    TextPager/TextPagerWidget.cpp
    TextPager/syntaxhighlighter.cpp)

if(ECFLOW_QT5)
    include_directories(${ECFLOW_QT_INCLUDE_DIR})
else()
    include(${QT_USE_FILE}) 
    set(ECFLOW_QT_LIBRARIES ${QT_LIBRARIES})
endif()


set(viewer_moc_files AbstractNodeModel.hpp
    AbstractNodeView.hpp
    AbstractSearchLine.hpp
    ActionHandler.hpp
    Animation.hpp
    AttributeEditor.hpp
    CaseSensitiveButton.hpp
    ChangeNotifyDialog.hpp
    ChangeNotifyEditor.hpp
    ChangeNotifyModel.hpp
    ChangeNotifyWidget.hpp
    ClockWidget.hpp
    CodeItemWidget.hpp
    ComboMulti.hpp
    CommandDesignerWidget.hpp    
    CommandOutput.hpp
    CommandOutputDialog.hpp
    CommandOutputWidget.hpp
    CustomCommandDialog.hpp
    CustomListWidget.hpp
    Dashboard.hpp
    DashboardDialog.hpp
    DashboardDock.hpp
    DashboardTitle.hpp
    DashboardWidget.hpp
    EditItemWidget.hpp
    FileWatcher.hpp
    FilterWidget.hpp
    GotoLineDialog.hpp
    HistoryItemWidget.hpp              
    HtmlItemWidget.hpp
    InfoPanel.hpp
    InputEventLog.hpp
    LabelEditor.hpp
    LimitEditor.hpp
    LineEdit.hpp
    LogProvider.hpp
    LogTruncator.hpp
    MainWindow.hpp
    MenuConfigDialog.hpp
    MessageItemWidget.hpp
    MeterEditor.hpp
    NodeFilterDialog.hpp
    NodePanel.hpp
    NodePathWidget.hpp
    NodeQueryCombo.hpp           
    NodeQueryEditor.hpp
    NodeQueryOptionEdit.hpp
    NodeQueryEngine.hpp
    NodeQueryResult.hpp
    NodeQueryResultModel.hpp
    NodeQueryResultView.hpp
    NodeSearchDialog.hpp
    NodeSearchWidget.hpp
    NodeWidget.hpp
    OneLineTextEdit.hpp
    OutputBrowser.hpp
    OutputCache.hpp
    OutputClient.hpp
    OutputFileClient.hpp
    OutputDirClient.hpp
    OutputItemWidget.hpp
    OutputFileProvider.hpp
    OutputDirProvider.hpp
    PlainTextEdit.hpp
    PropertyDialog.hpp             
    PropertyEditor.hpp
    PropertyLine.hpp
    SaveSessionAsDialog.hpp
    RepeatEditor.hpp
    RichTextEdit.hpp
    ServerComInfoWidget.hpp
    ServerComQueue.hpp
    ServerComThread.hpp
    ServerHandler.hpp
    ServerListDialog.hpp
    ServerListSyncWidget.hpp
    ServerSettingsItemWidget.hpp
    SessionDialog.hpp
    SessionRenameDialog.hpp
    ShellCommand.hpp
    StringMatchCombo.hpp
    SuiteItemWidget.hpp
    TabWidget.hpp
    TableFilterWidget.hpp
    TableNodeModel.hpp 
    TableNodeView.hpp 
    TableNodeViewDelegate.hpp
    TableNodeWidget.hpp             
    TextEditSearchLine.hpp
    TextFilterHandlerDialog.hpp
    TextFilterWidget.hpp
    TreeNodeModel.hpp
    TreeNodeView.hpp
    TreeNodeViewDelegate.hpp
    TreeNodeWidget.hpp    
    TriggerEditor.hpp
    TriggerItemWidget.hpp
    TriggerTableView.hpp
    TriggerTableWidget.hpp
    TriggeredScanner.hpp
    VariableEditor.hpp
    VariableItemWidget.hpp
    VariableModel.hpp
    VariableModelData.hpp
    VariableSearchLine.hpp
    VFilter.hpp
    VModelData.hpp
    VNodeList.hpp
    WhyItemWidget.hpp
    ZombieItemWidget.hpp
    TextPager/TextPagerCursor_p.hpp
    TextPager/TextPagerDocument.hpp
    TextPager/TextPagerDocument_p.hpp
    TextPager/TextPagerEdit.hpp
    TextPager/TextPagerEdit_p.hpp
    TextPager/TextPagerSection_p.hpp
    TextPager/TextPagerWidget.hpp
    TextPager/syntaxhighlighter.hpp   
)

set(viewer_wrap_ui_files
    AboutDialog.ui
    AttributeEditorDialog.ui
    ChangeNotifyDialog.ui
    ChangeNotifyDialogWidget.ui
    ChangeNotifyEditor.ui
    CommandDesignerWidget.ui 
    CommandOutputDialog.ui
    CommandOutputWidget.ui
    CustomCommandDialog.ui
    CodeItemWidget.ui
    DashboardDialog.ui
    DashboardDockTitleWidget.ui
    EditItemWidget.ui
    GotoLineDialog.ui
    HistoryItemWidget.ui
    HtmlItemWidget.ui
    InfoPanel.ui
    LabelEditorWidget.ui
    LimitEditorWidget.ui
    MainWindow.ui
    MessageItemWidget.ui
    MenuConfigDialog.ui
    MeterEditorWidget.ui
    NodeFilterDialog.ui
    NodeQueryEditor.ui
    NodeQuerySaveDialog.ui
    NodeSearchDialog.ui
    NodeSearchWidget.ui
    OutputItemWidget.ui 
    PropertyDialog.ui
    PropertyEditor.ui
    RepeatEditorWidget.ui
    SaveSessionAsDialog.ui
    SearchLineWidget.ui
    ServerAddDialog.ui
    ServerEditDialog.ui 
    ServerListDialog.ui
    ServerListSyncWidget.ui
    ServerSettingsItemWidget.ui
    SessionDialog.ui
    SessionRenameDialog.ui
    SuiteItemWidget.ui
    TableFilterWidget.ui
    TableNodeWidget.ui
    TextFilterAddDialog.ui
    TextFilterHandlerDialog.ui
    TextFilterWidget.ui
    TimeItemWidget.ui
    TreeNodeWidget.ui
    TriggerEditorWidget.ui
    TriggerItemWidget.ui
    TriggerTableWidget.ui
    VariableAddDialog.ui
    VariableEditorWidget.ui
    VariablePropDialog.ui
    VariableItemWidget.ui
    ZombieItemWidget.ui
)

if(ECFLOW_QT5)
  QT5_WRAP_CPP(VIEWER_MOC ${viewer_moc_files} )
  QT5_ADD_RESOURCES (VIEWER_RES viewer.qrc)
  QT5_WRAP_UI       (VIEWER_FORMS_HEADERS ${viewer_wrap_ui_files})
else()
  QT4_WRAP_CPP(VIEWER_MOC ${viewer_moc_files} )
  QT4_ADD_RESOURCES (VIEWER_RES viewer.qrc)
  QT4_WRAP_UI       (VIEWER_FORMS_HEADERS ${viewer_wrap_ui_files})
endif()


# add all the images as dependencies of the resource file so that it is
# automatically recompiled when an image changes
file( GLOB image_files "${CMAKE_CURRENT_SOURCE_DIR}/../images/*.*" )
ADD_CUSTOM_TARGET(Qt_resource_cpp DEPENDS ${VIEWER_RES})
ADD_DEPENDENCIES(Qt_resource_cpp ${image_files})



add_definitions( -DECFLOW_SHARED_DIR="${CMAKE_INSTALL_PREFIX}/share/ecflow" )


ecbuild_add_executable( TARGET   ecflow_ui.x
    SOURCES  ${viewer_srcs} ${VIEWER_MOC} ${VIEWER_RES} ${VIEWER_FORMS_HEADERS}
    INCLUDES .
     ../../ACore/src 
     ../../ANattr/src
     ../../ANode/src
     ../../ANode/test
     ../../Base/src
     ../../Base/src/cts
     ../../Base/src/stc
     ../../Client/src
     TextPager    
     ${Boost_INCLUDE_DIRS} 
     ${CMAKE_CURRENT_BINARY_DIR}
    LIBS core nodeattr node base libclient 
         pthread  
         m dl
         ${ECFLOW_QT_LIBRARIES}
         ${OPENSSL_LIBRARIES}
)

# This ensures that for debug config, we only link with debug boost libs, for other configs, we link with optimised boost libs
target_link_libraries(ecflow_ui.x debug ${Boost_REGEX_LIBRARY_DEBUG}   ${Boost_REGEX_LIBRARY_RELEASE} )


set(build_ecflow_ui_log 0)

if(${build_ecflow_ui_log})
    list(REMOVE_ITEM viewer_srcs ViewerMain.cpp)
    ecbuild_add_executable( TARGET   ecflow_ui_log
        SOURCES  LogEvent.cpp
                 ${viewer_srcs} ${VIEWER_MOC} ${VIEWER_RES} ${VIEWER_FORMS_HEADERS}
        INCLUDES .
         ../../ACore/src 
         ../../ANattr/src
         ../../ANode/src
         ../../ANode/test

=== debian/changelog ===
ecflow (4.9.0-3) unstable; urgency=medium

  * Temporarily drop slurm dependency that is blocking ecflow

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 21 May 2018 07:31:42 +0100

ecflow (4.9.0-2) unstable; urgency=medium

  * Patch for mips* FTBFS from James Cowgill. Closes: #875461

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 18 Apr 2018 13:41:58 +0100

ecflow (4.9.0-1) unstable; urgency=medium

  * New upstream release
  * Renamed: ecflow_logsvr -> ecflow_logserver
  * gcc7-fixes.patch upstream
  * logserver patch now obsolete
  * Standards-Version: 4.1.4

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Apr 2018 10:05:09 +0100

=== debian/control ===
Source: ecflow
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 10), 
  dh-buildinfo,
  dh-python, 
  python-dev, 
  python3-dev,
  cmake, 
  chrpath, 
  libmotif-dev, 
  libxpm-dev,
  libssl-dev,
  qtbase5-dev,
  libqt5gui5, 
  libqt5widgets5,
  libqt5core5a,
  libqt5network5,
  libqt5svg5-dev,
  libboost-test-dev, 
  libboost-serialization-dev,
  libboost-date-time-dev, 
  libboost-thread-dev,
  libboost-regex-dev, libboost-python-dev, 
  libboost-program-options-dev, libboost-filesystem-dev
Standards-Version: 4.1.4
Homepage: https://software.ecmwf.int/wiki/display/ECFLOW/The+ECFLOW+Pre-processor
Vcs-Browser: https://salsa.debian.org:/science-team/ecflow.git
Vcs-Git: https://salsa.debian.org:/science-team/ecflow.git

Package: libecflow-view0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Shared library for ecFlow worklow tools
 ecFlow is a meteorological work flow package that enables
 users to run a large number of programs ( with dependencies
 on each other and on time) in a controlled environment.
 . 
 This package contains a shared library used by ecflow tools.

Package: ecflow-server
Architecture: any
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}, ksh | mksh | pdksh | zsh
Description: Meteorological workflow controller - server 
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.


Package: ecflow-client
Architecture: any
Depends: libecflow-view0d ( = ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 ${python:Depends}
Description: Client tools for Meteorological workflow
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.
 .
 This package contains the client tools

Package: python-ecflow
Section: python
Architecture: any
Depends: libecflow-view0d ( = ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
 ${python:Depends}
Description: Python libraries for ecFlow workflow tools
 ecFlow is a meteorological work flow package that enables
 users to run a large number of programs ( with dependencies
 on each other and on time) in a controlled environment.
 .
 This package contains Python modules used in writing ecflow scripts. 

Package: python3-ecflow
Section: python
Architecture: any
Depends: libecflow-view0d ( = ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
 ${python:Depends}
Description: Python3 libraries for ecFlow workflow tools
 ecFlow is a meteorological work flow package that enables
 users to run a large number of programs ( with dependencies
 on each other and on time) in a controlled environment.
 .
 This package contains Python3 modules used in writing ecflow scripts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@  --with python2,python3 --with-buildsystem=cmake


DESTDIR:=`pwd`/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_CPU)

AUTOGENERATED:= ecflow-server.install ecflow-client.install libecflow-view0d.install
PY3:=$(shell py3versions -d)
PY3AB:=$(shell py3versions -d | sed -e 's/python3\./py3/' )
PY3VER:=$(shell py3versions -d | sed -e 's/python//' ) 

FPIC:= 
ifeq ($(TARGET_ARCH), hppa)
	FPIC:= -fPIC
endif

CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(FPIC) $(CPPFLAGS)  -DNO_REGEXP
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) $(FPIC)
CXXFLAGS:= $(shell dpkg-buildflags --get CXXFLAGS) $(FPIC) # -std=c++11

CMAKE_COMMON_FLAGS = \
                -DCMAKE_BUILD_TYPE=Release \
		-DDISABLE_OS_CHECK=ON \
		-DBOOST_INCLUDEDIR=/usr/include \
		-DBOOSTROOT=$(LIBDIR)	\
		-DENABLE_STATIC_BOOST_LIBS=OFF \
		-DENABLE_SSL=OFF \
		-DCMAKE_C_CFLAGS="${CFLAGS} ${LDFLAGS}"  

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(patsubst %, debian/%, ${AUTOGENERATED}) debian/build-*
	find . -name '*.pyc' -delete
	find . -name '*.job*' -delete

# For the moment set ENABLE_SSL=OFF. Enabling it fails tests

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure --builddirectory=debian/build-py2 -- \
		${CMAKE_COMMON_FLAGS} \
		-DPYTHON_MIN_VERSION=2.7 \
		-DBoost_PYTHON_LIBRARY_RELEASE=$(LIBDIR)/libboost_python-py27.so
	dh_auto_configure --builddirectory=debian/build-py3 -- \
		${CMAKE_COMMON_FLAGS} \
		-DPYTHON_MIN_VERSION=${PY3VER} \
		-DBoost_PYTHON_LIBRARY_RELEASE=$(LIBDIR)/libboost_python-${PY3AB}.so

override_dh_auto_build:
	dh_auto_build  --builddirectory=debian/build-py2
	dh_auto_build  --builddirectory=debian/build-py3

override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build-py2
	dh_auto_install --builddirectory=debian/build-py3
	#	Drop the suffixes on scripts ...
	mv $(DESTDIR)/usr/bin/ecflow_logserver.sh $(DESTDIR)/usr/bin/ecflow_logserver
	mv $(DESTDIR)/usr/bin/ecflow_start.sh 	$(DESTDIR)/usr/bin/ecflow_start
	mv $(DESTDIR)/usr/bin/ecflow_stop.sh 	$(DESTDIR)/usr/bin/ecflow_stop
	mv $(DESTDIR)/usr/bin/ecflow_test_ui.sh 	$(DESTDIR)/usr/bin/ecflow_test_ui
